package gq.unurled.raxen.components.player.attributes;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.entity.EntityNamespacedKey;
import org.bukkit.entity.Player;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

public class Attributes {

    private static EntityNamespacedKey namespacedKey;

    public Attributes(Raxen main) {
        namespacedKey = new EntityNamespacedKey(main);
    }

    public static Attribute getAttribute(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        int maxHealth, health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg, maxMana, mana, itemMana, luck, itemLuck;
        maxHealth = data.get(namespacedKey.maxHealth, PersistentDataType.INTEGER);
        health = data.get(namespacedKey.healthKey, PersistentDataType.INTEGER);
        itemHealth = data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER);
        defense = data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER);
        itemDefense = data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER);
        speed = data.get(namespacedKey.speedKey, PersistentDataType.INTEGER);
        itemSpeed = data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER);
        strength = data.get(namespacedKey.strengthKey , PersistentDataType.INTEGER);
        itemDmg = data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER);
        mana = data.get(namespacedKey.mana, PersistentDataType.INTEGER);
        itemMana = data.get(namespacedKey.itemMana, PersistentDataType.INTEGER);
        maxMana = data.get(namespacedKey.maxMana, PersistentDataType.INTEGER);
        luck = data.get(namespacedKey.luck, PersistentDataType.INTEGER);
        itemLuck = data.get(namespacedKey.itemLuck, PersistentDataType.INTEGER);
        return new Attribute(maxHealth, health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg, maxMana, mana, itemMana, luck, itemLuck);
    }

    public static void setAttributes(Player player, int maxHealth, int health, int itemHealth, int defense, int itemDefense, int speed, int itemSpeed, int strength, int itemDmg, int maxMana, int mana, int itemMana, int luck, int itemLuck) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxHealth, PersistentDataType.INTEGER, maxHealth);
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, health);
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, itemHealth);
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, defense);
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, itemDefense);
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, speed);
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, itemSpeed);
        data.set(namespacedKey.strengthKey , PersistentDataType.INTEGER, strength);
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, itemDmg);
        data.set(namespacedKey.maxMana, PersistentDataType.INTEGER, maxMana);
        data.set(namespacedKey.mana, PersistentDataType.INTEGER, mana);
        data.set(namespacedKey.itemMana, PersistentDataType.INTEGER, itemMana);
        data.set(namespacedKey.luck, PersistentDataType.INTEGER, luck);
        data.set(namespacedKey.itemLuck, PersistentDataType.INTEGER, itemLuck);
    }

    public void removeSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, data.get(namespacedKey.speedKey, PersistentDataType.INTEGER) -i);
    }
    public void removeHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, data.get(namespacedKey.healthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) -i);
    }
    public void removeStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.mana, PersistentDataType.INTEGER, data.get(namespacedKey.mana, PersistentDataType.INTEGER) -i);
    }
    public void removeMaxMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxMana, PersistentDataType.INTEGER, data.get(namespacedKey.maxMana, PersistentDataType.INTEGER) -i);
    }
    public void removeMaxHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxHealth, PersistentDataType.INTEGER, data.get(namespacedKey.maxHealth, PersistentDataType.INTEGER) -i);
    }
    public void removeLuck(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.luck, PersistentDataType.INTEGER, data.get(namespacedKey.luck, PersistentDataType.INTEGER) -i);
    }

    public void removeItemSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemMana, PersistentDataType.INTEGER, data.get(namespacedKey.itemMana, PersistentDataType.INTEGER) -i);
    }
    public void removeItemLuck(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemLuck, PersistentDataType.INTEGER, data.get(namespacedKey.itemLuck, PersistentDataType.INTEGER) -i);
    }

    public void addSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, data.get(namespacedKey.speedKey, PersistentDataType.INTEGER) +i);
    }
    public void addHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, data.get(namespacedKey.healthKey, PersistentDataType.INTEGER) +i);
    }
    public void addDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) +i);
    }
    public void addStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER) +i);
    }
    public void addMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.mana, PersistentDataType.INTEGER, data.get(namespacedKey.mana, PersistentDataType.INTEGER) +i);
    }
    public void addMaxMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxMana, PersistentDataType.INTEGER, data.get(namespacedKey.maxMana, PersistentDataType.INTEGER) +i);
    }
    public void addMaxHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxHealth, PersistentDataType.INTEGER, data.get(namespacedKey.maxHealth, PersistentDataType.INTEGER) +i);
    }
    public void addLuck(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.luck, PersistentDataType.INTEGER, data.get(namespacedKey.luck, PersistentDataType.INTEGER) +i);
    }

    public void addItemSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemMana, PersistentDataType.INTEGER, data.get(namespacedKey.itemMana, PersistentDataType.INTEGER) +i);
    }
    public void addItemLuck(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemLuck, PersistentDataType.INTEGER, data.get(namespacedKey.itemLuck, PersistentDataType.INTEGER) +i);
    }

    public Integer getSpeed(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.speedKey, PersistentDataType.INTEGER);
    }
    public Integer getStrength(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER);
    }
    public Integer getHealth(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.healthKey, PersistentDataType.INTEGER);
    }
    public Integer getDefense(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER);
    }
    public Integer getMana(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.mana, PersistentDataType.INTEGER);
    }
    public Integer getMaxMana(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.maxMana, PersistentDataType.INTEGER);
    }
    public Integer getMaxHealth(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.maxHealth, PersistentDataType.INTEGER);
    }
    public Integer getLuck(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.luck, PersistentDataType.INTEGER);
    }

    public Integer getItemSpeed(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER);
    }
    public Integer getItemStrength(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER);
    }
    public Integer getItemHealth(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER);
    }
    public Integer getItemDefense(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER);
    }
    public Integer getItemMana(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.itemMana, PersistentDataType.INTEGER);
    }
    public Integer getItemLuck(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.itemLuck, PersistentDataType.INTEGER);
    }

    public void setHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, i);
    }
    public void setDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, i);
    }
    public void setSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, i);
    }
    public void setStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, i);
    }
    public void setMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.mana, PersistentDataType.INTEGER, i);
    }
    public void setMaxMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxMana, PersistentDataType.INTEGER, i);
    }
    public void setMaxHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxHealth, PersistentDataType.INTEGER, i);
    }
    public void setLuck(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.luck, PersistentDataType.INTEGER, i);
    }

    public void setItemHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, i);
    }
    public void setItemDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, i);
    }
    public void setItemSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, i);
    }
    public void setItemStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, i);
    }
    public void setItemMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.mana, PersistentDataType.INTEGER, i);
    }
    public void setItemLuck(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemLuck, PersistentDataType.INTEGER, i);
    }
}
