package gq.unurled.raxen.components.player.classes;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.manager.entity.PlayerManager;
import lombok.Getter;
import lombok.Setter;
import org.bukkit.Bukkit;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;

import static gq.unurled.raxen.utils.Utils.debug;
import static gq.unurled.raxen.utils.Utils.error;

public class Classes {

    private final Raxen main;
    @Getter
    private HashMap<String, Class> classes = new HashMap<>();

    public Classes(Raxen main) {
        this.main = main;
    }

    public void register() {
        File folder = new File(main.getDataFolder() + "/Class/");
        File[] listFile = folder.listFiles();
        PlayerManager pm = main.getManager().getPlayerManager();
        for (int i = 0; i < listFile.length; i++) {
            if (listFile[i].isFile()) {
                FileConfiguration customClass = new YamlConfiguration();
                try {
                    customClass.load(listFile[i]);
                } catch (IOException | InvalidConfigurationException e) {
                    e.printStackTrace();
                }
                resultClass cla = registerClass(customClass);
                pm.addClasses(cla.getClas(), cla.getId());
            } else if (listFile[i].isDirectory()) {
                for (int a = 0; a < listFile[i].listFiles().length; a++) {
                    if(listFile[i].listFiles()[a].isFile()) {
                        FileConfiguration customClass = new YamlConfiguration();
                        try {
                            customClass.load(listFile[i].listFiles()[a]);
                        } catch (IOException | InvalidConfigurationException e) {
                            e.printStackTrace();
                        }
                        resultClass cla = registerClass(customClass);
                        pm.addClasses(cla.getClas(), cla.getId());
                    } else if (listFile[i].listFiles()[a].isDirectory()) {
                        error((Raxen) Bukkit.getPluginManager().getPlugin("Raxen"),"Can't use more than 2 folder to get Class.yml");
                    }

                }
            }
        }
    }

    public class resultClass {
        @Getter
        @Setter
        public Class clas;
        @Getter
        @Setter
        public String id;
        public resultClass(Class clas, String id) {
            this.clas = clas;
            this.id = id;
        }
    }

    public resultClass registerClass(FileConfiguration file) {
        String id = file.getString("id");
        debug(id);
        return new resultClass(new Class(file.getString("name"), file.getString("color-name"), id, file.getString("item_placeholder"), file.getInt("max_level")), id);
    }

    public void registerClass(Class clas) {
        debug(clas.getID());
        resultClass result = new resultClass(clas, clas.getID());
        classes.put(result.getId(), result.getClas());
    }
}
