package gq.unurled.raxen.listener.player;

import com.destroystokyo.paper.event.player.PlayerArmorChangeEvent;
import de.tr7zw.nbtapi.NBTItem;
import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.player.PlayerUtils;
import gq.unurled.raxen.components.player.attributes.Attributes;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;

public class ArmorEvent implements Listener {

    private Raxen main;

    public ArmorEvent(Raxen main) {
        this.main = main;
    }

    @EventHandler
    public void ArmorChangeEvent(PlayerArmorChangeEvent e) {
        Player player = e.getPlayer();
        Attributes attributes = new Attributes(main);
        if(e.getOldItem() != null && e.getOldItem().getType() != Material.AIR) {
            ItemStack oldItem = e.getOldItem();
            NBTItem nbti = new NBTItem(oldItem);
            if(nbti.hasKey("SPEED")) {
                attributes.removeSpeed(player, nbti.getInteger("SPEED"));
            }
            if(nbti.hasKey("HEALTH")) {
                attributes.removeHealth(player, nbti.getInteger("HEALTH"));
            }
            if(nbti.hasKey("DEFENSE")) {
                attributes.removeDefense(player, nbti.getInteger("DEFENSE"));
            }
            if(nbti.hasKey("STRENGTH")) {
                attributes.removeStrength(player, nbti.getInteger("STRENGTH"));
            }
        }
        if(e.getNewItem() != null && e.getNewItem().getType() != Material.AIR) {
            ItemStack newItem = e.getNewItem();
            NBTItem nbti = new NBTItem(newItem);
            if(nbti.hasKey("SPEED")) {
                attributes.addSpeed(player, nbti.getInteger("SPEED"));
            }
            if(nbti.hasKey("HEALTH")) {
                attributes.addHealth(player, nbti.getInteger("HEALTH"));
            }
            if(nbti.hasKey("DEFENSE")) {
                attributes.addDefense(player, nbti.getInteger("DEFENSE"));
            }
            if(nbti.hasKey("STRENGTH")) {
                attributes.addStrength(player, nbti.getInteger("STRENGTH"));
            }
        }
        PlayerUtils.updateSkills(main, player);
    }
}
