package gq.unurled.raxen.listener.player;

import de.tr7zw.nbtapi.NBTItem;
import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.player.PlayerUtils;
import gq.unurled.raxen.components.player.attributes.Attributes;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerItemHeldEvent;
import org.bukkit.inventory.ItemStack;

public class ItemHandEvent implements Listener {

    private Raxen main;

    public ItemHandEvent(Raxen main) {
        this.main = main;
    }

    @EventHandler
    public void ItemHeldEvent(PlayerItemHeldEvent e) {
        Player player = e.getPlayer();
        Attributes attributes = new Attributes(main);
        ItemStack oldItem = player.getInventory().getItem(e.getPreviousSlot());
        ItemStack newItem = player.getInventory().getItem(e.getNewSlot());
        if(oldItem != null && oldItem.getType() != Material.AIR) {
            NBTItem nbti = new NBTItem(oldItem);
            if(nbti.hasKey("SPEED")) {
                attributes.removeItemSpeed(player, nbti.getInteger("SPEED"));
            }
            if(nbti.hasKey("HEALTH")) {
                attributes.removeItemHealth(player, nbti.getInteger("HEALTH"));
            }
            if(nbti.hasKey("DEFENSE")) {
                attributes.removeItemDefense(player, nbti.getInteger("DEFENSE"));
            }
            if(nbti.hasKey("STRENGTH")) {
                attributes.removeItemStrength(player, nbti.getInteger("STRENGTH"));
            }
        }
        if(newItem != null && newItem.getType() != Material.AIR) {
            NBTItem nbti = new NBTItem(newItem);
            if(nbti.hasKey("SPEED")) {
                attributes.addItemSpeed(player, nbti.getInteger("SPEED"));
            }
            if(nbti.hasKey("HEALTH")) {
                attributes.addItemHealth(player, nbti.getInteger("HEALTH"));
            }
            if(nbti.hasKey("DEFENSE")) {
                attributes.addItemDefense(player, nbti.getInteger("DEFENSE"));
            }
            if(nbti.hasKey("STRENGTH")) {
                attributes.addItemStrength(player, nbti.getInteger("STRENGTH"));
            }
        }
        PlayerUtils.updateSkills(main, player);
    }
}
