package gq.unurled.raxen.listener.player;

import gq.unurled.raxen.Raxen;
import lombok.Getter;
import lombok.Setter;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.server.ServerListPingEvent;

import static gq.unurled.raxen.utils.Utils.colorTextComp;

public class ServerPingEvent implements Listener {

    private Raxen main;
    @Getter
    @Setter
    private boolean loading = false;

    public ServerPingEvent(Raxen main) {
        this.main = main;
        this.loading = true;
    }

    @EventHandler
    public void ServerListPingEvent(ServerListPingEvent e) {
        FileConfiguration config = this.main.getConfig();
        String motd = config.getString("motd");
        String motdReload = config.getString("motd-reload");
        if (loading) {
            e.motd(colorTextComp(motdReload));
        } else {
            e.motd(colorTextComp(motd));
        }
    }
}
