package gq.unurled.raxen.manager;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.manager.entity.*;
import gq.unurled.raxen.manager.server.*;
import lombok.Getter;

public class Manager {

    @Getter
    private static WorldManager worldManager;
    @Getter
    private static StorageManager storageManager;
    @Getter
    private static PlayerManager playerManager;
    @Getter
    private static ListenerManager listenerManager;
    @Getter
    private static CommandManager commandManager;
    @Getter
    private ItemManager itemManager;
    @Getter
    private ResourcePackManager resourcePackManager;
    @Getter
    private EntityManager entityManager;
    @Getter
    private LootManager lootManager;
    @Getter
    private LibsManager libsManager;

    public void set(Raxen main) {
        libsManager = new LibsManager(main);

        worldManager = new WorldManager(main);
        storageManager = new StorageManager(main);

        //Managers
        itemManager = new ItemManager(main);
        playerManager = new PlayerManager(main);
        listenerManager = new ListenerManager(main);
        commandManager = new CommandManager(main);
        resourcePackManager = new ResourcePackManager(main);
        entityManager = new EntityManager(main);
        lootManager = new LootManager(main);
    }
}
