package gq.unurled.raxen.manager.server;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.utils.libs.*;
import lombok.Getter;

public class LibsManager {
    @Getter
    private final ProtocolManager protocolManager;
    @Getter
    private final LuckPerm luckPerm;
    @Getter
    private final Vault vault;
    @Getter
    private final MongoDB mongoDB;
    @Getter
    private static Mysql mysql;
    @Getter
    private PlaceHolderAPI placeHolderAPI;
    @Getter
    private Citizens citizens;

    public LibsManager(Raxen main) {
        this.luckPerm = new LuckPerm(main);
        this.luckPerm.register();
        this.vault = new Vault(main);
        this.protocolManager = new ProtocolManager(main);
        this.mongoDB = new MongoDB();
        this.placeHolderAPI = new PlaceHolderAPI(main);
        this.citizens = new Citizens(main);
    }
}
